--
--Taunt Tattle Rehashed
--Author: Kasani - Agamaggan-US
--Original: CasualCorps
--
--
	versiontext = "v1.2.0";
	prefixtext="[Taunt Tattle Rehashed]: ";
	
	settingvars = "NONE";
	
--TTR = {}; -- core table
--local TTR_DB = TTR_DB or {};

--TTR_DB = TTR_DB or {}
TTR_DB = {}; -- old save table
	--TTR_DB = TTR_DB or {};
--TTR_DBX = {}; -- new save table
	--TTR_DB;
	--TTR_DBX;

	TTR_Defaults = {
			ttr_isEnabled	=	true;
		ttr_isEnabledWhile	=	{true,true,true,false};
			ttr_isSelfOnly	=	true;
				ttr_isIgnMT	=	false;
			ttr_isInGroup	=	true;
			ttr_isAloneOn	=	false;
			ttr_isStanceOn	=	true;
		ttr_WhisperNonTank	=	true;
		ttr_optionalspells	=	{};
		ttr_ignoredplayers	=	{};
	ttr_ignoredplayersvars	= 	true;
	}
	--TTR_DB = TTR_DBX or TTR_Defaults;

  SpellsTauntCS = {	--Cast Success
		-- Warrior
		355,	--Taunt
		--114192,	--Mocking Banner
		-- Paladin
		--31789,	--Righteous Defense
		62124,	--Hand of Reckoning
		-- Druid
		6795,	--Growl
		-- Death Knight
		-- 49576,	--Death Grip (Pull)
		56222,	--Dark Command
		--Demon Hunter
		185245,	--Torment
		-- Monk
		115546,	--Provoke
		--115180,	--Dizzying Haze
		--121253,	--Optional: Keg Smash
		-- Warlock
		--97827,	--Provocation
		17735,	--Pet - Suffering (Voidwalker/Voidlord)
		-- Shaman
		--73684,	--Unleash Elements - Rockbiter
		36213,	--Pet Earth Elemental - Taunt
		-- Hunter
		--20736,	--Distracting Shot
		2649	--Pet - Growl
			
		
		-- Legacy or Unknown
		--5209,	
		--1161,	
		--694		
		};
  
  SpellsTauntAA = {	--Aura Applies
		-- Death Knight
		51399,	--Death Grip (Taunt)
		};
  
  SpellsStanceCS = {--Cast Success
			--Shaman
		--8017 --Rockbiter
		};
  
  SpellsStanceAA = {--Aura Applies
		--Warrior
		--71,		--Defensive stance
		--Paladin
		--25780,	--Righteous Fury
		--Druid
		5487,	--Bear Form
		--Death Knight
		48263,	--Blood Presence
		--42650,	--Army of the Dead
		--Monk
		--115069,	--Stance of the Sturdy Ox
		--Shaman
		--2062,	--Earth Elemental Totem
		--Warlock
		--114168,	--Dark Apotheosis 
		112042,	--Pet - Threatening Presence (Voidwalker/Voidlord)
		134477	--Pet - Threatening Presence (Felguard/Wrathguard)
		};

local scanTool = CreateFrame( "GameTooltip", "ScanTooltip", nil, "GameTooltipTemplate" );
scanTool:SetOwner( WorldFrame, "ANCHOR_NONE" );
local scanText = _G["ScanTooltipTextLeft2"]; -- This is the line with <[Player]'s Pet>
function getPetOwner(petName)
   scanTool:ClearLines()
   scanTool:SetUnit(petName)
   local ownerText = scanText:GetText()
   if not ownerText then return "" end
   local owner, _ = string.split("'",ownerText)
   
   if(string.find(ownerText, "'s Pet") or string.find(ownerText, "'s Minion")) then
		return owner
	else
		return ""
   end
   
   --return owner -- This is the pet's owner
end
  

  SLASH_TTR1 = '/ttr'; -- 3.
function SlashCmdList.TTR(msg, editbox) -- 4.
	if (TTR_DB.ttr_isEnabled == nil or TTR_DB.ttr_isEnabled == true) then
		ttr_isEnabledText = "On";
		else
		ttr_isEnabledText = "Off";
	end
	if (TTR_DB.ttr_isSelfOnly == nil or TTR_DB.ttr_isSelfOnly == false) then
		ttr_isSelfOnlyText = "Off";
		else
		ttr_isSelfOnlyText = "On";
	end
	if (TTR_DB.ttr_isIgnMT == nil or TTR_DB.ttr_isIgnMT == false) then
		ttr_isIgnMTText = "Off";
		else
		ttr_isIgnMTText = "On";
	end
	if (TTR_DB.ttr_isInGroup == nil or TTR_DB.ttr_isInGroup == true) then
		ttr_isInGroupText = "On";
		else
		ttr_isInGroupText = "Off";
	end
	if (TTR_DB.ttr_isAloneOn == nil or TTR_DB.ttr_isAloneOn == false) then
		ttr_isAloneOnText = "Off";
		else
		ttr_isAloneOnText = "On";
	end
	if (TTR_DB.ttr_isStanceOn == nil or TTR_DB.ttr_isStanceOn == true) then
		ttr_isStanceOnText = "On";
		else
		ttr_isStanceOnText = "Off";
	end
	if (TTR_DB.ttr_WhisperNonTank == nil or TTR_DB.ttr_WhisperNonTank == false) then
		ttr_WhisperNonTankText = "Off";
		else
		ttr_WhisperNonTankText = "On";
	end
	--if ( == nil or 
	--ttr_ignoredplayersvars
	
	--print(msg);
if (msg == nil or msg == "" or msg == "options") then
	TauntTattleOptionsFrame_Show();
elseif (msg == "help" or msg == "?") then
	print("[Taunt Tattle Rehashed] "..versiontext.." by Kasani - Agamaggan-US\n  Option Commands are listed below\n  Toggle Announcements ("..ttr_isEnabledText.."): /ttr toggle (/ttr tg)\n  Toggle Self Only Mode ("..ttr_isSelfOnlyText.."): /ttr selfonly (/ttr so)\n  Toggle Ignore Main Tank Mode ("..ttr_isIgnMTText.."): /ttr ignoremt (/ttr imt)\n  Toggle In Party Mode ("..ttr_isInGroupText.."): /ttr inparty (/ttr ip)\n  Toggle Alone Mode ("..ttr_isAloneOnText.."): /ttr alone (/ttr al)\n  Toggle Stance Mode ("..ttr_isStanceOnText.."): /ttr stance (/ttr st)\n  Toggle Whisper NonTank ("..ttr_WhisperNonTankText.."): /ttr whisper (/ttr wnt)");
elseif (msg == "toggle" or msg == "tg") then
	if(TTR_DB.ttr_isEnabled == false) then
		TTR_DB.ttr_isEnabled = true;
		print("[Taunt Tattle Rehashed] is now Enabled.");
	else
		TTR_DB.ttr_isEnabled = false;
		print("[Taunt Tattle Rehashed] is now Disabled.");
	end
	
	
elseif (msg == "self only" or msg == "selfonly" or msg == "so") then
	if(TTR_DB.ttr_isSelfOnly == false) then
		TTR_DB.ttr_isSelfOnly = true;
		print("[Taunt Tattle Rehashed] Announcements will now only send to you.");
	else
		TTR_DB.ttr_isSelfOnly = false;
		print("[Taunt Tattle Rehashed] Announcements will now send to party or raid.");
	end
	
	
elseif (msg == "ignore main tank" or msg == "ignore mt" or msg == "ignoremaintank" or msg == "ignoremt" or msg == "imt") then
	if(TTR_DB.ttr_isIgnMT == false) then
		TTR_DB.ttr_isIgnMT = true;
		print("[Taunt Tattle Rehashed] Announcements will now ignore players marked as 'Tank'.");
	else
		TTR_DB.ttr_isIgnMT = false;
		print("[Taunt Tattle Rehashed] Announcements will now send all taunts.");
	end
	
	
elseif (msg == "in party" or msg == "inparty" or msg == "ip") then
	if(ttr_isInGroup == false) then
		ttr_isInGroup = true;
		print("[Taunt Tattle Rehashed] Announcements will now check if source is in party or raid.");
	else
		ttr_isInGroup = false;
		print("[Taunt Tattle Rehashed] Announcements will now include all sources.");
	end
	
	
elseif (msg == "alone" or msg == "al") then
	if(TTR_DB.ttr_isAloneOn == false) then
		TTR_DB.ttr_isAloneOn = true;
		print("[Taunt Tattle Rehashed] Announcements will now tattle if you are alone (not in group/raid).");
	else
		TTR_DB.ttr_isAloneOn = false;
		print("[Taunt Tattle Rehashed] Announcements will not tattle if you are alone (not in group/raid).");
	end
	
	
elseif (msg == "stance" or msg == "st") then
	if(TTR_DB.ttr_isStanceOn == false) then
		TTR_DB.ttr_isStanceOn = true;
		print("[Taunt Tattle Rehashed] Announcements will now scan for Stance changes.");
	else
		TTR_DB.ttr_isStanceOn = false;
		print("[Taunt Tattle Rehashed] Announcements will now ignore stances.");
	end
	
	
elseif (msg == "whisper" or msg == "wnt") then
	if(TTR_DB.ttr_WhisperNonTank == false) then
		TTR_DB.ttr_WhisperNonTank = true;
		print("[Taunt Tattle Rehashed] will now whisper players not flagged as tank (Only for players in party/raid).");
	else
		TTR_DB.ttr_WhisperNonTank = false;
		print("[Taunt Tattle Rehashed] will not whisper anyone.");
	end

elseif (msg == "ignore" or msg == "ig") then
	IgnorePlayerToggle();
	
elseif (msg == "ignorelist" or msg == "iglist") then
	Listttr_ignoredplayers();
elseif (msg == "ignorereset" or msg == "igre") then
	Resetttr_ignoredplayers();
elseif (msg == "ignoreautoreset" or msg == "igar") then
	if(TTR_DB.ttr_ignoredplayersvars == false) then
		TTR_DB.ttr_ignoredplayersvars = true;
		print("[Taunt Tattle Rehashed] Ignored players will be cleared on new session.");
	else
		TTR_DB.ttr_ignoredplayersvars = false;
		print("[Taunt Tattle Rehashed] Ignored players will save between sessions.");
	end
--elseif (msg == "lfg") then
	-- if (GetLFGMode() == nil) then
		-- print("[Taunt Tattle Rehashed] NOLFG");
	-- else 
		-- print("[Taunt Tattle Rehashed] "..GetLFGMode());
	-- end
	--if(IsInInstance()) then
		--print("[Taunt Tattle Rehashed] "..IsInInstance());
	--end
	-- GetLFGMode()
		-- print("[Taunt Tattle Rehashed] INSTANCE_CHAT");
	-- else
		-- print("[Taunt Tattle Rehashed] RAID");
	-- end
end

end

	--TTR_DB.ttr_isEnabled, TTR_DB.ttr_isEnabledWhile, TTR_DB.ttr_isSelfOnly, TTR_DB.ttr_isIgnMT, TTR_DB.ttr_isInGroup, TTR_DB.ttr_isAloneOn, TTR_DB.ttr_isStanceOn, TTR_DB.ttr_WhisperNonTank, TTR_DB.ttr_optionalspells, TTR_DB.ttr_ignoredplayers, TTR_DB.ttr_ignoredplayersvars
	


function SetVariables()
		--TTR_DB = TTR_DBX;
		for i, v in pairs(TTR_Defaults) do
		if TTR_DB[i] == nil then
			TTR_DB[i] = v;
			settingvars = settingvars..", "..tostring(i);
			--ChatFrame1:AddMessage(prefixtext..versiontext.." VARTEST "..tostring(i).."  "..tostring(v).." VS "..tostring(TTR_DB[i]).." VS "..tostring(TTR_DBX[i]));
			end
		end
	--ChatFrame1:AddMessage(prefixtext..versiontext.." Setting Variables "..tostring(settingvars));
end

function TauntTattleOptionsFrame_OnEvent(event, ...)
	local timestamp, ttype, hideCaster, srcGUID, srcName, srcFlags, sourceRaidFlags, dstGUID, dstName, dstFlags, destRaidFlags, spellid, spellname, spellschool, targetchan, isGo, OKTOCcontinue, b_or_d = select(1, ...);
	if (event == "ADDON_LOADED") and (timestamp == "TauntTattleRehashed") then
		--ChatFrame1:AddMessage("Addon Loaded: "..timestamp);
		if TTR_DBX == nil then
			TTR_DB = TTR_Defaults
		else
			TTR_DB = TTR_DBX
		end
		TauntTattleOptionsFrame_OnShow()
		SetVariables()
		--TauntTattleFrame:UnregisterEvent("ADDON_LOADED")
	end	
	if (event == "PLAYER_LOGOUT") then
		TTR_DBX = TTR_DB;
		--TauntTattleFrame:UnregisterEvent("ADDON_LOADED")
	end
	
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
	if (TTR_DB.ttr_isEnabled == true) then
	local ingroup = IsInGroup();

	
	
	
if((ingroup == false) and (TTR_DB.ttr_isAloneOn == false)) then
--print("Trigger1");
elseif(
	(UnitInRaid(srcName) and TTR_DB.ttr_isInGroup == true)
	or
	(UnitInParty(srcName) and TTR_DB.ttr_isInGroup == true)
	or
	(TTR_DB.ttr_isInGroup == false)
	) then
--print("Trigger2");
	
	--ChatFrame1:AddMessage("TTR_DEV: "..spellid);
	if (
		(
			(ttype == "SPELL_CAST_SUCCESS")
			and
			(
				inTable(SpellsTauntCS, spellid)
				or 
				(
					inTable(SpellsStanceCS, spellid)
					and
					(TTR_DB.ttr_isStanceOn == true)
				)
			)
		)
		or
 		(
			(ttype == "SPELL_AURA_APPLIED")
			and 
			(
				inTable(SpellsTauntAA, spellid)
				or 
				(
					inTable(SpellsStanceAA, spellid)
					and
					(TTR_DB.ttr_isStanceOn == true)
				)
			)
		)
	) then
		local TauntType = 0;
		if(	inTable(SpellsTauntCS, spellid) or inTable(SpellsTauntAA, spellid)	) then TauntType=1; end
		if(	inTable(SpellsStanceCS, spellid) or inTable(SpellsStanceAA, spellid)	) then TauntType=2; end
		
		
		
		local ttr_current_ChannelContinue = false;
		local ttr_current_ModalContinue = false;
		
		
		local ttr_current_NameSplit = string.split("-",srcName);
		local ttr_current_NameNoServer = ttr_current_NameSplit;
		local ttr_current_isSelf = UnitIsUnit(srcName, "player");
		local ttr_current_inRaid = IsInRaid();
		local ttr_current_inGroup = IsInGroup();
		local ttr_current_inInstance = IsInGroup(LE_PARTY_CATEGORY_INSTANCE);
		local ttr_current_sendChannel = "";
		local ttr_current_targetAssignment = UnitGroupRolesAssigned(srcName);
		local ttr_current_isIgnored = inTable(TTR_DB.ttr_ignoredplayers, ttr_current_NameNoServer);
		local ttr_current_PetOwner = getPetOwner(srcName);
		local ttr_current_PetOwnerSelf = false;
			if(ttr_current_PetOwner ~= "") then
				ttr_current_PetOwnerSelf = UnitIsUnit(ttr_current_PetOwner, "player");
				ttr_current_isSelf = ttr_current_PetOwnerSelf;
			end
		local ttr_current_Messages = {
					spellname.." used to taunt "..dstName.." by "..srcName,
					spellname.." used by ".. srcName
				};
		local ttr_current_MessagesPetAdd = " (PET OF "..getPetOwner(srcName)..")";
		local ttr_currnet_MessageCombine = "";
		
	--print(tostring(TTR_DB.ttr_isEnabledWhile[2]) .. " " .. tostring(ttr_current_inRaid));
	if(		ttr_current_isIgnored	or		( TTR_DB.ttr_isIgnMT and ttr_current_targetAssignment == "TANK" )	) then
	else
	
			ttr_currnet_MessageCombine = prefixtext .. ttr_current_Messages[TauntType];
			if(ttr_current_PetOwner ~= "") then
				ttr_currnet_MessageCombine = ttr_currnet_MessageCombine .. ttr_current_MessagesPetAdd;
			end
		
		if(ttr_current_inInstance) then
			ttr_current_sendChannel = "INSTANCE_CHAT";
			if(UnitInBattleground("player")) then
				ttr_current_ChannelContinue = TTR_DB.ttr_isEnabledWhile[4];
			else
				ttr_current_ChannelContinue = TTR_DB.ttr_isEnabledWhile[3];
			end
		elseif(ttr_current_inRaid) then
			ttr_current_sendChannel = "RAID";
			ttr_current_ChannelContinue = TTR_DB.ttr_isEnabledWhile[2];
		elseif(ttr_current_inGroup) then
			ttr_current_sendChannel = "PARTY";
			ttr_current_ChannelContinue = TTR_DB.ttr_isEnabledWhile[1];
		else
			ttr_current_ChannelContinue = true;
		end
		
		
		--No modals yet, so set it to true
		ttr_current_ModalContinue=true;
		
		
		if ( ttr_current_ChannelContinue and ttr_current_ModalContinue ) then
			if(TTR_DB.ttr_isSelfOnly) then
				print(ttr_currnet_MessageCombine);
			else
				SendChatMessage(ttr_currnet_MessageCombine, ttr_current_sendChannel);
				if(TTR_DB.ttr_WhisperNonTank and ttr_current_isSelf==false and ttr_current_targetAssignment ~= "TANK") then
					if(ttr_current_PetOwner ~= "") then
						SendChatMessage(prefixtext.." Your pet ("..srcName..") is taunting, please disable "..spellname..".", "WHISPER", nil, ttr_current_PetOwner);
					else
						SendChatMessage(prefixtext.." You are not the tank. Please do not use "..spellname, "WHISPER", nil, srcName);
					end
				end
			end
		end
		
	end
		
	end
	
	
	--else
	
--print("Trigger3");
end
	
	
	
	

	end
	end
	
end


function inTable(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end

function inTableList(tbl)
	List = "";
    for key, value in pairs(tbl) do
        List = List..value..", ";
    end
    return List
end
function DetectInstanceChange()
	print("Instance Change!");
end



function IgnorePlayerToggle()
	if(UnitName("target")) then
		local targetname = UnitName("target");
		if(inTable(TTR_DB.ttr_ignoredplayers, targetname)) then
			tremove(TTR_DB.ttr_ignoredplayers, inTable(TTR_DB.ttr_ignoredplayers, targetname));
			print("[Taunt Tattle Rehashed] Will no longer ignore "..targetname);
		else
			tinsert(TTR_DB.ttr_ignoredplayers, targetname);
			print("[Taunt Tattle Rehashed] Will now ignore "..targetname);
		end
	else
		print("[Taunt Tattle Rehashed] Please target someone to ignore.");
	end
end

function Listttr_ignoredplayers()
	print("[Taunt Tattle Rehashed] Players in ignore list:\n"..inTableList(TTR_DB.ttr_ignoredplayers));
end

function Resetttr_ignoredplayers()
	TTR_DB.ttr_ignoredplayers = {};
	print("[Taunt Tattle Rehashed] Ignored players cleared");
end






function TauntTattleOptionsFrame_OnLoad(TTRAddon)
--TTRAddon = {};
		TTRAddon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		TTRAddon:RegisterEvent("ADDON_LOADED");
		TTRAddon:RegisterEvent("PLAYER_LOGOUT");
		ChatFrame1:AddMessage("|cffffff00 Taunt Tattle Rehashed Loaded. Type /ttr for options.");
	TTRAddon.name = GetAddOnMetadata("TauntTattleRehashed", "Title");
	TTRAddon.okay = TauntTattleOptionsFrame_Save;
	TTRAddon.cancel = TauntTattleOptionsFrame_Cancel;
	TTRAddon.default = TauntTattleOptionsFrame_SetDefaultOptions;
	InterfaceOptions_AddCategory(TTRAddon);
	
	--SetVariables();
	
	--TTRAddon:Hide();
end
function TauntTattleOptionsFrame_Show()
	InterfaceOptionsFrame_OpenToCategory(TTRAddon);
end
function TauntTattleOptionsFrame_OnShow()
	Header2:SetText("Version "..versiontext);

	ckbEnabled:SetChecked(TTR_DB.ttr_isEnabled);
	chkSOMode:SetChecked(TTR_DB.ttr_isSelfOnly);
	ckbIMTMode:SetChecked(TTR_DB.ttr_isIgnMT);
	ckbIPMode:SetChecked(TTR_DB.ttr_isInGroup);
	ckbALMode:SetChecked(TTR_DB.ttr_isAloneOn);
	ckbSTMode:SetChecked(TTR_DB.ttr_isStanceOn);
	ckbWNTMode:SetChecked(TTR_DB.ttr_WhisperNonTank);
	ckbIGARMode:SetChecked(TTR_DB.ttr_ignoredplayersvars);
	
	--ckbIGARMode:SetChecked(TTR_DB.ttr_ignoredplayersvars);
	
	ckbEnWhileA:SetChecked(TTR_DB.ttr_isEnabledWhile[1]);
	ckbEnWhileB:SetChecked(TTR_DB.ttr_isEnabledWhile[2]);
	ckbEnWhileC:SetChecked(TTR_DB.ttr_isEnabledWhile[3]);
	ckbEnWhileD:SetChecked(TTR_DB.ttr_isEnabledWhile[4]);
	--if(inTable(TTR_DB.ttr_optionalspells, 115180))
	--	ckbOpSp115180:SetChecked(true);
	--else
	--	ckbOpSp115180:SetChecked(false);
	--end
	CancelOptions = { };
	CancelOptions.ttr_isEnabled = TTR_DB.ttr_isEnabled;
	CancelOptions.ttr_isSelfOnly = TTR_DB.ttr_isSelfOnly;
	CancelOptions.ttr_isIgnMT = TTR_DB.ttr_isIgnMT;
	CancelOptions.ttr_isInGroup = TTR_DB.ttr_isInGroup;
	CancelOptions.ttr_isAloneOn = TTR_DB.ttr_isAloneOn;
	CancelOptions.ttr_isStanceOn = TTR_DB.ttr_isStanceOn;
	CancelOptions.ttr_WhisperNonTank = TTR_DB.ttr_WhisperNonTank;
	CancelOptions.ttr_ignoredplayersvars = TTR_DB.ttr_ignoredplayersvars;
		--CancelOptions.ckbOpSp115180 = ckbOpSp115180:GetChecked();
		
	CancelOptions.ttr_isEnabledWhile = TTR_DB.ttr_isEnabledWhile;
end


function TauntTattleOptionsFrame_Save()
	--print("ttr Save");
end
function TauntTattleOptionsFrame_OnHide()
	--print("ttr Save");
	CancelOptions = nil
end
function TauntTattleOptionsFrame_Cancel()
	--print("ttr Cancel");
	if CancelOptions then
	TTR_DB.ttr_isEnabled = CancelOptions.ttr_isEnabled;
	TTR_DB.ttr_isSelfOnly = CancelOptions.ttr_isSelfOnly;
	TTR_DB.ttr_isIgnMT = CancelOptions.ttr_isIgnMT;
	TTR_DB.ttr_isInGroup = CancelOptions.ttr_isInGroup;
	TTR_DB.ttr_isAloneOn = CancelOptions.ttr_isAloneOn;
	TTR_DB.ttr_isStanceOn = CancelOptions.ttr_isStanceOn;
	TTR_DB.ttr_WhisperNonTank = CancelOptions.ttr_WhisperNonTank;
		--TTR_DB.ttr_optionalspells[1] = CancelOptions.ckbOpSp115180;
	TTR_DB.ttr_isEnabledWhile = CancelOptions.ttr_isEnabledWhile;
	end
end


function TauntTattleOptionsFrame_SetDefaultOptions()
	--print("ttr Default");
end

function TauntTattleOptionsFrame_CBEnable(f)
	TTR_DB.ttr_isEnabled = f;
end

function TauntTattleOptionsFrame_CBSOMode(f)
	TTR_DB.ttr_isSelfOnly = f;
end

function TauntTattleOptionsFrame_CBIMTMode(f)
	TTR_DB.ttr_isIgnMT = f;
end

function TauntTattleOptionsFrame_CBIPMode(f)
	TTR_DB.ttr_isInGroup = f;
end

function TauntTattleOptionsFrame_CBALMode(f)
	TTR_DB.ttr_isAloneOn = f;
end

function TauntTattleOptionsFrame_CBSTMode(f)
	TTR_DB.ttr_isStanceOn = f;
		--print("[Taunt Tattle Rehashed] StanceMode.".. tostring(TTR_DB.ttr_isStanceOn) .." -> "..tostring(f));
end

function TauntTattleOptionsFrame_CBWNTMode(f)
	TTR_DB.ttr_WhisperNonTank = f;
end

function TauntTattleOptionsFrame_CBIGARMode(f)
	TTR_DB.ttr_ignoredplayersvars = f;
end

function TauntTattleOptionsFrame_EnWhenA(f)
	TTR_DB.ttr_isEnabledWhile[1] = f;
end

function TauntTattleOptionsFrame_EnWhenB(f)
	TTR_DB.ttr_isEnabledWhile[2] = f;
end

function TauntTattleOptionsFrame_EnWhenC(f)
	TTR_DB.ttr_isEnabledWhile[3] = f;
end

function TauntTattleOptionsFrame_EnWhenD(f)
	TTR_DB.ttr_isEnabledWhile[4] = f;
end


function TauntTattleOptionsFrame_ttr_optionalspells(spell, f)
	TTR_DB.ttr_optionalspells[spell] = f;
end